# Auto Deployment VMs from Template with CSV file - Reza Ardaneh
# Specify vCenter Server, vCenter Server username and vCenter Server user password
$vCenter=""
$vCenterUser=""
$vCenterPassword="	"
Connect-viserver $vCenter -user $vCenterUser -password $vCenterPassword -WarningAction 0

# StartPoint
$vms = Import-CSV "C:\Users\ardan\Desktop\Bulk_VMs\ImportVMs.csv"
 
foreach ($vm in $vms){
# Assign Variables
$Template = Get-Template -Name $vm.Template
$Cluster = $vm.Cluster
$Datastore = Get-Datastore -Name $vm.Datastore
$Custom = Get-OSCustomizationSpec -Name $vm.Customization
$vCPU = $vm.vCPU
$Memory = $vm.Memory
$Network = $vm.Network
$Location = $vm.Location
$VMName = $vm.Name

# Clone the "Master" OS Customization Spec, then use it to apply vm specific IP configuration
$Cloned_Customization = Get-OSCustomizationSpec $vm.Customization | New-OSCustomizationSpec -name "$($vm.Customization)_$($vm.name)"
Set-OSCustomizationNicMapping -OSCustomizationNicMapping ($Cloned_Customization | Get-OscustomizationNicMapping) -Position 1 -IpMode UseStaticIp -IpAddress $vm.ip -SubnetMask $vm.SubnetMask -DefaultGateway $vm.Gateway -DNS $DNS1 | Out-Null

# Where the VM gets built
New-VM -Name $VMName -Template $Template -ResourcePool $Cluster -Location $Location -StorageFormat Thick -Datastore $Datastore -OSCustomizationSpec $Cloned_Customization
Start-Sleep -Seconds 10
 
# Where the vCPU, Memory, and Network gets set
$NewVM = Get-VM -Name $VMName
$NewVM | Set-VM -MemoryGB $Memory -NumCpu $vCPU -Confirm:$false
$NewVM | Get-NetworkAdapter | Set-NetworkAdapter -NetworkName $Network -Confirm:$false
}
####### Start VM
foreach ($vm in $vms){
      $VMName = $vm.Name
      Start-VM -VM $VMName -Confirm:$False
}

#Clean-up the cloned OS Customization spec
$OSCustRemove = Get-OSCustomizationSpec -Name "$($vm.Customization)_*"
Get-OSCustomizationSpec -Name $OSCustRemove | Remove-OSCustomizationSpec -Confirm:$false